#!/bin/sh

#
# $Id: startup-freebsd.sh,v 1.2 2006/06/03 17:18:59 mickey Exp $
#
# FreeBSD boot time start up script for vserver(8).
#
# PROVIDE: vserver
# REQUIRE: LOGIN
# KEYWORD: FreeBSD shutdown

#
# Add the following line to /etc/rc.conf to enable vserver:
#
# vserver_enable="YES"
#
# Additional commandline qualifiers to be passed to vserver(8) may
# be specified in /etc/rc.conf by adding:
#
# vserver_flags="<your commandline qualifiers here>"
#
# See vserver(8) for a detailed description of vserver commandline qualifiers.
#

. /etc/rc.subr

name=vserver
rcvar=`set_rcvar`

command=/usr/local/sbin/vserver
required_files=/usr/local/etc/vchat/user.db

# read settings, set default values

load_rc_config "$name"
: ${vserver_enable="NO"}
: ${vserver_flags=""}
: ${vserver_user="vchat"}
: ${vserver_group="vchat"}
: ${vserver_pidfile="/usr/local/etc/vchat/vserver.pid"}

command_args="/DETACH"

run_rc_command "$1"
