/*****************************************************************************
 * This file is part of the VChat conference server distribution.            *
 *                                                                           *
 * Copyright (c) 1993 - 2009 Andreas S. Wetzel                               *
 * All rights reserved.                                                      *
 *                                                                           *
 * The contents of this file are subject to the terms of the GNU General     *
 * Public License (GPL), version 2 only ("the License") as published by the  *
 * Free Software Foundation.                                                 *
 *                                                                           *
 * This Software comes with ABSOLUTELY NO WARRANTY.                          *
 * See the License for more details. You should have received a copy of the  *
 * License along with this distribution; See the file COPYING. If not, write *
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,   *
 * Boston, MA 02110-1301 USA.                                                *
 *****************************************************************************/
 
/* $Id: pqfuncs.c,v 1.4 2009/08/14 11:57:37 mickey Exp $ */

#include "vchatctl.h"

/*
 * Externals.
 */

extern struct sockaddr_un vsaddr;

/*
 * Globals.
 */

char *prog_name;
int errcount = 0;

/*
 * Parameter definitions:
 */

PQDEF pn_vchatctl =
{ PARAMETER(PN_VCHATCTL), "VCHATCTL", PQARG_NONE, "" };

PQDEF pn_vchatcgictl =
{ PARAMETER(PN_VCHATCGICTL), "VCHATCGICTL", PQARG_NONE, "" };

PQDEF pn_vchatwclist =
{ PARAMETER(PN_VCHATWCLIST), "VCHATWCLIST", PQARG_NONE, "" };

PQDEF pn_add =
{ PARAMETER(PN_ADD), "ADD", PQARG_NONE, "" };

PQDEF pn_delete =
{ PARAMETER(PN_DELETE), "DELETE", PQARG_NONE, "" };

PQDEF pn_exit =
{ PARAMETER(PN_EXIT), "EXIT", PQARG_NONE, "" };

PQDEF pn_flush =
{ PARAMETER(PN_FLUSH), "FLUSH", PQARG_NONE, "" };

PQDEF pn_help =
{ PARAMETER(PN_HELP), "HELP", PQARG_NONE, "" };

PQDEF pn_kill =
{ PARAMETER(PN_KILL), "KILL", PQARG_NONE, "" };

PQDEF pn_quit =
{ PARAMETER(PN_QUIT), "QUIT", PQARG_NONE, "" };

PQDEF pn_send =
{ PARAMETER(PN_SEND), "SEND", PQARG_NONE, "" };

PQDEF pn_set =
{ PARAMETER(PN_SET), "SET", PQARG_NONE, "" };

PQDEF pn_show =
{ PARAMETER(PN_SHOW), "SHOW", PQARG_NONE, "" };

PQDEF pn_stop =
{ PARAMETER(PN_STOP), "STOP", PQARG_NONE, "" };

PQDEF pn_acl =
{ PARAMETER(PN_ACL), "ACL", PQARG_NONE, "" };

PQDEF pr_user =
{ PARAMETER(PN_USER), "USER", PQARG_MANDATORY | PQARG_STRING, "nickname" };

PQDEF pr_anonymous =
{ PARAMETER(PR_ANONYMOUS), "ANONYMOUS", PQARG_MANDATORY | PQARG_BOOL, "bool" };

PQDEF pr_dnschklvl =
{ PARAMETER(PR_DNSCHKLVL), "DNSCHKLVL", PQARG_MANDATORY | PQARG_STRING, "lvlspec" };

PQDEF pr_email =
{ PARAMETER(PR_EMAIL), "EMAIL", PQARG_MANDATORY | PQARG_BOOL, "bool" };

PQDEF pr_fgthreshold =
{ PARAMETER(PR_FGTHRESHOLD), "FGTHRESHOLD", PQARG_MANDATORY | PQARG_NUM, "sec" };

PQDEF pr_floodguard =
{ PARAMETER(PR_FLOODGUARD), "FLOODGUARD", PQARG_MANDATORY | PQARG_BOOL, "bool" };

PQDEF pr_regonly =
{ PARAMETER(PR_REGONLY), "REGONLY", PQARG_MANDATORY | PQARG_BOOL, "bool" };

PQDEF pr_servername =
{ PARAMETER(PR_SERVERNAME), "SERVERNAME", PQARG_MANDATORY | PQARG_STRING, "fqdn" };

PQDEF pr_socket =
{ PARAMETER(PR_SOCKET), "SOCKET", PQARG_MANDATORY | PQARG_STRING, "path" };

PQDEF pn_anonymous =
{ PARAMETER(PN_ANONYMOUS), "ANONYMOUS", PQARG_NONE, "" };

PQDEF pn_dnschklvl =
{ PARAMETER(PN_DNSCHKLVL), "DNSCHKLVL", PQARG_NONE, "" };

PQDEF pn_email =
{ PARAMETER(PN_EMAIL), "EMAIL", PQARG_NONE, "" };

PQDEF pn_fgthreshold =
{ PARAMETER(PN_FGTHRESHOLD), "FGTHRESHOLD", PQARG_NONE, "" };

PQDEF pn_floodguard =
{ PARAMETER(PN_FLOODGUARD), "FLOODGUARD", PQARG_NONE, "" };

PQDEF pn_lastlog =
{ PARAMETER(PN_LASTLOG), "LASTLOG", PQARG_NONE, "" };

PQDEF pn_regonly =
{ PARAMETER(PN_REGONLY), "REGONLY", PQARG_NONE, "" };

PQDEF pn_servername =
{ PARAMETER(PN_SERVERNAME), "SERVERNAME", PQARG_NONE, "" };

PQDEF pn_socket =
{ PARAMETER(PN_SOCKET), "SOCKET", PQARG_NONE, "" };

PQDEF pn_uptime =
{ PARAMETER(PN_UPTIME), "UPTIME", PQARG_NONE, "" };

PQDEF pn_users =
{ PARAMETER(PN_USERS), "USERS", PQARG_NONE, "" };

PQDEF pn_version =
{ PARAMETER(PN_VERSION), "VERSION", PQARG_NONE, "" };

PQDEF pr_aclrule =
{ PARAMETER(PR_ACLRULE), "ACLRULE", PQARG_MANDATORY | PQARG_NUM, "rule#" };

PQDEF pr_address =
{ PARAMETER(PR_ADDRESS), "ADDRESS", PQARG_MANDATORY | PQARG_NETADDR, "netaddr" };

PQDEF pr_password =
{ PARAMETER(PR_PASSWORD), "PASSWORD", PQARG_MANDATORY | PQARG_STRING, "passwd" };

PQDEF pn_server =
{ PARAMETER(PN_SERVER), "SERVER", PQARG_NONE, "" };

/*
 * Qualifiers definitions:
 */

PQDEF qr_socket =
{ QUALIFIER(QR_SOCKET), "SOCKET", PQARG_MANDATORY | PQARG_STRING, "path" };

PQDEF qr_ttl =
{ QUALIFIER(QR_TTL), "TTL", PQARG_MANDATORY | PQARG_NUM, "sec" };

PQDEF qr_expires =
{ QUALIFIER(QR_EXPIRES), "EXPIRES", PQARG_MANDATORY | PQARG_FDATE, "date" };

PQDEF qr_channel =
{ QUALIFIER(QR_CHANNEL), "CHANNEL", PQARG_MANDATORY | PQARG_NUM, "channel" };

PQDEF qn_accept =
{ QUALIFIER(QN_ACCEPT), "ACCEPT", PQARG_NONE, "" };

PQDEF qn_reject =
{ QUALIFIER(QN_REJECT), "REJECT", PQARG_NONE, "" };

PQDEF qn_silent =
{ QUALIFIER(QN_SILENT), "SILENT", PQARG_NONE, "" };

PQDEF qn_all =
{ QUALIFIER(QN_ALL), "ALL", PQARG_NONE, "" };

PQDEF qn_broadcast =
{ QUALIFIER(QN_BROADCAST), "BROADCAST", PQARG_NONE, "" };

PQDEF qr_address =
{ QUALIFIER(QR_ADDRESS), "ADDRESS", PQARG_MANDATORY | PQARG_NETADDR, "netaddr" };

PQDEF qr_host =
{ QUALIFIER(QR_HOST), "HOST", PQARG_MANDATORY | PQARG_STRING, "fqdn" };

PQDEF qr_uname =
{ QUALIFIER(QR_UNAME), "UNAME", PQARG_MANDATORY | PQARG_STRING, "username" };

PQDEF qr_records =
{ QUALIFIER(QR_RECORDS), "RECORDS", PQARG_MANDATORY | PQARG_NUM, "number" };

PQDEF qr_since =
{ QUALIFIER(QR_SINCE), "SINCE", PQARG_MANDATORY | PQARG_PDATE, "date" };

PQDEF qr_until =
{ QUALIFIER(QR_UNTIL), "UNTIL", PQARG_MANDATORY | PQARG_PDATE, "date" };

PQDEF qr_user =
{ QUALIFIER(QR_USER), "USER", PQARG_MANDATORY | PQARG_STRING, "nickname" };

PQDEF qn_wide =
{ QUALIFIER(QN_WIDE), "WIDE", PQARG_NONE, "" };

/*****************************************************************************
 * VCHATCTL ADD subcommands:                                                 *
 *****************************************************************************/

int pqf_add_aclrule(int argc, char *argv[], PQLINK *pql)
{
	uint32_t pqid;

	VCTL_ACL vacl;
	uint8_t flags = 0;
#define	ADDRESS_SET	0x01
#define ACTION_SET	0x02
#define EXPIRES_SET	0x04

	/*
	 * Clear rule, default to reject.
	 */

	bzero(&vacl, sizeof(vacl));
	vacl.rule = pqvalue;

	/*
	 * Parse parameters/Qualifiers.
	 */

	pqindex = 0;

	while((pqid = getnextpq(argc, argv, pql, 0)) != PQ_EXHAUSTED)
	{
		if(pqchkfail(pqid))
		{
			return -1;
		}
		else if(pqid == PARAMETER(PR_ADDRESS))
		{
			if(flags & ADDRESS_SET)
			{
				printf("%s: Multiple ADDRESS parameters "
					"encountered.\n", pqpath);
				return -1;
			}
			else
			{
				bcopy(&pqaddress, &vacl.address, sizeof(vacl.address));
				bcopy(&pqnetmask, &vacl.netmask, sizeof(vacl.netmask));
				flags |= ADDRESS_SET;
			}
		}
		else if(pqid == QUALIFIER(QN_ACCEPT))
		{
			if(flags & ACTION_SET)
			{
				printf("%s: Multiple rule action qualifiers "
					"encountered.\n", pqpath);
				return -1;
			}
			else
			{
				vacl.flags |= VCTL_ACL_ACCEPT;
				flags |= ACTION_SET;
			}
		}
		else if(pqid == QUALIFIER(QN_REJECT))
		{
			if(flags & ACTION_SET)
			{
				printf("%s: Multiple rule action qualifiers "
					"encountered.\n", pqpath);
				return -1;
			}
			else
			{
				vacl.flags &= ~VCTL_ACL_ACCEPT;
				flags |= ACTION_SET;
			}
		}
		else if(pqid == QUALIFIER(QR_TTL))
		{
			if(flags & EXPIRES_SET)
			{
				printf("%s: Multiple rule life cycle "
					"qualifiers encountered.\n", pqpath);
				return -1;
			}
			else
			{
				vacl.expires = pqvalue;
				vacl.flags |= VCTL_ACL_TTL;
				flags |= EXPIRES_SET;
			}
		}
		else if(pqid == QUALIFIER(QR_EXPIRES))
		{
			if(flags & EXPIRES_SET)
			{
				printf("%s: Multiple rule life cycle "
					"qualifiers encountered.\n", pqpath);
				return -1;
			}
			else
			{
				vacl.expires = pqdate;
				vacl.flags &= ~VCTL_ACL_TTL;
				flags |= EXPIRES_SET;
			}
		}
	}

	argc -= pqindex;
	argv += pqindex;

	if(!(flags & ADDRESS_SET))
	{
		printf("%s: A required parameter is missing.\n", pqpath);
		return -1;
	}

	acl_add(&vacl);

	return 0;
}

int pqf_add_user(int argc, char *argv[], PQLINK *pql)
{
	uint32_t pqid;
	char *nick = pqarg;
	char *passwd = NULL;

	/*
	 * Parse parameters/Qualifiers.
	 */

	pqindex = 0;

	while((pqid = getnextpq(argc, argv, pql, 0)) != PQ_EXHAUSTED)
	{
		if(pqchkfail(pqid))
		{
			return -1;
		}
		else if(pqid == PARAMETER(PR_PASSWORD))
		{
			if(!passwd)
			{
				passwd = pqarg;
			}
			else
			{
				printf("%s: Multiple PASSWORD parameters "
					"encountered.\n", pqpath);
				return -1;
			}
		}
	}

	argc -= pqindex;
	argv += pqindex;

	if(!nick || !passwd)
	{
		printf("%s: A required parameter is missing.\n", pqpath);
		return -1;
	}

	user_add(nick, passwd);

	return 0;
}

/*****************************************************************************
 * VCHATCTL DELETE subcommands:                                              *
 *****************************************************************************/

int pqf_delete_aclrule(int argc, char *argv[], PQLINK *pql)
{
	uint16_t rule = pqvalue;

	if(pqcheckend(argc, argv))
		return -1;

	acl_delete(rule);

	return 0;

}

int pqf_delete_user(int argc, char *argv[], PQLINK *pql)
{
	char *nick = pqarg;

	if(pqcheckend(argc, argv))
		return -1;

	user_delete(nick);

	return 0;
}

/*****************************************************************************
 * VCHATCTL FLUSH subcommands:                                               *
 *****************************************************************************/

int pqf_flush_acl(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	if(isatty(0))
	{
		if(promptkey("yn", "Flush server access control list?") == 'y')
		{
			printf("Affirmative\n");
			acl_flush();
		}
		else
		{
			printf("Negative\n");
		}
	}
	else
	{
		acl_flush();
	}

	return 0;
}

/*****************************************************************************
 * VCHATCTL SEND command:                                                    *
 *****************************************************************************/

int pqf_send(int argc, char *argv[], PQLINK *pql)
{
	uint32_t pqid;
	PQLINK *pqlnk = (PQLINK *)0;
	int32_t channel = 0;
	char *nick = NULL;
	uint8_t action = 0;

	pqindex = 0;

	while((pqid = getnextpq(argc, argv, pql, &pqlnk)) != PQ_EXHAUSTED)
	{
		if(pqchkfail(pqid))
		{
			return -1;
		}
		else if(action && (pqid == QUALIFIER(QN_BROADCAST)
		|| pqid == QUALIFIER(QR_CHANNEL)
		|| pqid == QUALIFIER(QR_USER)))
		{
			printf("%s: The /%s, /%s and /%s qualifiers are "
				"mutually exclusive.\n", pqpath,
				qn_broadcast.name, qr_channel.name,
				qr_user.name);
			return -1;
		}
		else if(pqid == QUALIFIER(QN_BROADCAST))
		{
			action = 1;
		}
		else if(pqid == QUALIFIER(QR_CHANNEL))
		{
			channel = pqvalue;
			action = 2;
		}
		else if(pqid == QUALIFIER(QR_USER))
		{
			nick = pqarg;
			action = 3;
		}
	}

	argc -= pqindex;
	argv += pqindex;

	if(!action)
	{
		printf("%s: No message target specified.\n", pqpath);
		return -1;
	}

	switch(action)
	{
		case 1:	broadcast();
			break;

		case 2:	cnmessage(channel, NULL);
			break;

		case 3:	cnmessage(-0xD00F, pqarg);
			break;
	}

	return 0;
}

/*****************************************************************************
 * VCHATCTL SET subcommands:                                                 *
 *****************************************************************************/

int pqf_set_anonymous(int argc, char *argv[], PQLINK *pql)
{
	uint8_t onoff = pqbool;

	if(pqcheckend(argc, argv))
		return -1;

	anonymous(&onoff);	

	return 0;
}

int pqf_set_dnschklvl(int argc, char *argv[], PQLINK *pql)
{
	char *arg = pqarg;
	uint8_t lvl;

	if(pqcheckend(argc, argv))
		return -1;

	if((lvl = dnslvlparse(arg)) == 0xFF)
	{
		printf("%s: Invalid DNS check level '%s' encountered.\n", pqpath, arg);
		printf("%s: Valid levels are 'NONE', 'FWD', 'REV' and 'STRICT'.\n", pqpath);
		return -1;
	}

	dnschklvl(&lvl);

	return 0;
}

int pqf_set_email(int argc, char *argv[], PQLINK *pql)
{
	uint8_t onoff = pqbool;

	if(pqcheckend(argc, argv))
		return -1;

	email(&onoff);	

	return 0;
}

int pqf_set_fgthreshold(int argc, char *argv[], PQLINK *pql)
{
	uint32_t val = pqvalue;

	if(pqcheckend(argc, argv))
		return -1;

	fgthreshold(&val);	

	return 0;
}

int pqf_set_floodguard(int argc, char *argv[], PQLINK *pql)
{
	uint8_t onoff = pqbool;

	if(pqcheckend(argc, argv))
		return -1;

	floodguard(&onoff);	

	return 0;
}

int pqf_set_regonly(int argc, char *argv[], PQLINK *pql)
{
	uint8_t onoff = pqbool;

	if(pqcheckend(argc, argv))
		return -1;

	regonly(&onoff);	

	return 0;
}

int pqf_set_servername(int argc, char *argv[], PQLINK *pql)
{
	char *name = pqarg;

	if(pqcheckend(argc, argv))
		return -1;

	servername(name);	

	return 0;
}

int pqf_set_socket(int argc, char *argv[], PQLINK *pql)
{
	char *path = pqarg;

	if(pqcheckend(argc, argv))
		return -1;

	vsaddr.sun_family = AF_LOCAL;
	sncopy(path, vsaddr.sun_path, sizeof(vsaddr.sun_path));
#if HAVE_SUN_LEN
	vsaddr.sun_len = SUN_LEN(&vsaddr);
#endif
	printf("Using '%s' for server communication.\n", vsaddr.sun_path);

	return 0;
}

/*****************************************************************************
 * VCHATCTL SHOW subcommands:                                                *
 *****************************************************************************/

int pqf_show_acl(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	acl_list();

	return 0;
}

int pqf_show_anonymous(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	anonymous((uint8_t *)0);

	return 0;
}

int pqf_show_dnschklvl(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	dnschklvl((uint8_t *)0);

	return 0;
}

int pqf_show_email(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	email((uint8_t *)0);

	return 0;
}

int pqf_show_fgthreshold(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	fgthreshold(NULL);

	return 0;
}

int pqf_show_floodguard(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	floodguard((uint8_t *)0);

	return 0;
}

int pqf_show_lastlog(int argc, char *argv[], PQLINK *pql)
{
	uint32_t pqid;
	uint8_t flags = 0;
	int wide = 0;
	PQLINK *pqlnk = (PQLINK *)0;
	VCTL_LLQUERY query;

	/*
	 * Setup default query.
	 */

	bzero(&query, sizeof(query));

	query.records = 50;
	query.address.s_addr = query.netmask.s_addr = INADDR_ANY;

	/*
	 * Parse parameters/Qualifiers.
	 */

	pqindex = 0;

	while((pqid = getnextpq(argc, argv, pql, &pqlnk)) != PQ_EXHAUSTED)
	{
		if(pqchkfail(pqid))
		{
			return -1;
		}
		else if(pqid == QUALIFIER(QR_ADDRESS))
		{
			if(flags & 0x01)
			{
				printf("Multiple /%s qualifiers encountered."
					"\n", pqlnk->pqd->name);
				return -1;
			}
			else
			{
				bcopy(&pqaddress, &query.address, sizeof(query.address));
				bcopy(&pqnetmask, &query.netmask, sizeof(query.netmask));
				flags |= 0x01;
			}
		}
		else if(pqid == QUALIFIER(QR_HOST))
		{
			if(flags & 0x02)
			{
				printf("Multiple /%s qualifiers encountered."
					"\n", pqlnk->pqd->name);
				return -1;
			}
			else
			{
				sncopy(pqarg, query.host, sizeof(query.host));
				flags |= 0x02;
			}
		}
		else if(pqid == QUALIFIER(QR_USER))
		{
			if(flags & 0x04)
			{
				printf("Multiple /%s qualifiers encountered."
					"\n", pqlnk->pqd->name);
				return -1;
			}
			else
			{
				if(nick_ok(pqarg))
				{
					sncopy(pqarg, query.nick, sizeof(query.nick));
				}
				else
				{
					printf("Nickname '%s' is invalid.", pqarg);
					return -1;
				}

				flags |= 0x04;
			}
		}
		else if(pqid == QUALIFIER(QR_RECORDS))
		{
			if(flags & 0x08)
			{
				printf("Multiple /%s qualifiers encountered."
					"\n", pqlnk->pqd->name);
				return -1;
			}
			else
			{
				query.records = pqvalue;
				flags |= 0x08;
			}
		}
		else if(pqid == QUALIFIER(QR_SINCE))
		{
			if(flags & 0x10)
			{
				printf("Multiple /%s qualifiers encountered."
					"\n", pqlnk->pqd->name);
				return -1;
			}
			else
			{
				query.since = pqdate;
				flags |= 0x10;
			}
		}
		else if(pqid == QUALIFIER(QR_UNTIL))
		{
			if(flags & 0x20)
			{
				printf("Multiple /%s qualifiers encountered."
					"\n", pqlnk->pqd->name);
				return -1;
			}
			else
			{
				query.until = pqdate;
				flags |= 0x20;
			}
		}
		else if(pqid == QUALIFIER(QR_UNAME))
		{
			if(flags & 0x40)
			{
				printf("Multiple /%s qualifiers encountered."
					"\n", pqlnk->pqd->name);
				return -1;
			}
			else
			{
				sncopy(pqarg, query.user, sizeof(query.user));
				flags |= 0x40;
			}
		}
		else if(pqid == QUALIFIER(QN_WIDE))
		{
			wide = 1;
		}
	}

	argc -= pqindex;
	argv += pqindex;

	lastlog(&query, wide);

	return 0;
}

int pqf_show_regonly(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	regonly((uint8_t *)0);

	return 0;
}

int pqf_show_servername(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	servername(NULL);

	return 0;
}

int pqf_show_socket(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	printf("Using '%s' for server communication.\n",
		vsaddr.sun_path);

	return 0;
}

int pqf_show_uptime(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	uptime();

	return 0;
}

int pqf_show_users(int argc, char *argv[], PQLINK *pql)
{
	uint32_t pqid;
	int32_t channel = 0;
	int32_t *pchannel = (int32_t *)0;

	pqindex = 0;

	while((pqid = getnextpq(argc, argv, pql, 0)) != PQ_EXHAUSTED)
	{
		if(pqchkfail(pqid))
		{
			return -1;
		}
		else if(pqid == QUALIFIER(QR_CHANNEL))
		{
			channel = pqvalue;
			pchannel = &channel;			
		}
	}

	argc -= pqindex;
	argv += pqindex;

	ulist(pchannel);

	return 0;
}

int pqf_show_version(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	printf("VCHATCTL %s - %s\n", PACKAGE_VERSION, PACKAGE_RELDATE);
	printf("(c) 1993-2009 by Andreas S. Wetzel\nAll rights reserved\n");
	printf("Licensed under the GNU General Public License, version 2 only\n");

	return 0;
}

/*****************************************************************************
 * VCHATCTL STOP subcommands:                                                *
 *****************************************************************************/

int pqf_stop_server(int argc, char *argv[], PQLINK *pql)
{
	if(pqcheckend(argc, argv))
		return -1;

	if(isatty(0))
	{
		if(promptkey("yn", "Shut down VChat conference server?") == 'y')
		{
			printf("Affirmative\n");
			shut_down();
		}
		else
		{
			printf("Negative\n");
		}
	}
	else
	{
		shut_down();
	}

	return 0;
}

/*****************************************************************************
 * VCHATCTL KILL command:                                                    *
 *****************************************************************************/

int pqf_kill(int argc, char *argv[], PQLINK *pql)
{
	uint32_t pqid;
	uint8_t silent = 0;
	uint8_t target = 0;
	char *nick = NULL;
	int32_t channel = 0;

	pqindex = 0;

	while((pqid = getnextpq(argc, argv, pql, 0)) != PQ_EXHAUSTED)
	{
		if(pqchkfail(pqid))
		{
			return -1;
		}
		else if(target && (pqid == QUALIFIER(QR_USER)
		|| pqid == QUALIFIER(QR_CHANNEL)
		|| pqid == QUALIFIER(QN_ALL)))
		{
			printf("%s: The /%s, /%s and /%s qualifiers are "
				"mutually exclusive.\n", pqpath,
				qr_user.name, qr_channel.name, qn_all.name);
			return -1;
		}
		else if(pqid == QUALIFIER(QN_SILENT))
		{
			silent = 1;
		}
		else if(pqid == QUALIFIER(QR_USER))
		{
			nick = pqarg;
			target = 1;
		}
		else if(pqid == QUALIFIER(QR_CHANNEL))
		{
			channel = pqvalue;
			target = 2;
		}
		else if(pqid == QUALIFIER(QN_ALL))
		{
			target = 3;
		}
	}

	argc -= pqindex;
	argv += pqindex;

	if(!target)
	{
		printf("%s: No target specified.\n", pqpath);
		return -1;
	}

	switch(target)
	{
		case 1:	killuser(nick, silent);
			break;

		case 2:	if(isatty(0))
			{
				if(promptkey("yn", "Kill all users on channel %d?", channel) == 'y')
				{
					printf("Affirmative\n");
					killchannel(channel, silent);
				}
				else
				{
					printf("Negative\n");
				}
			}
			else
			{
				killchannel(channel, silent);
			}
			break;

		case 3:	if(isatty(0))
			{
				if(promptkey("yn", "Kill all users?") == 'y')
				{
					printf("Affirmative\n");
					killall(silent);
				}
				else
				{
					printf("Negative\n");
				}
			}
			else
			{
				killall(silent);
			}
			break;
	}

	return 0;
}

/*****************************************************************************
 * VCHATCTL command:                                                         *
 *****************************************************************************/

int pqf_vchatctl(int argc, char *argv[], PQLINK *pql)
{
	uint32_t pqid;
	PQLINK *pqlnk = (PQLINK *)0;

	pqindex = 0;

	while((pqid = getnextpq(argc, argv, pql, &pqlnk)) != PQ_EXHAUSTED)
	{
		if(pqchkfail(pqid))
		{
			if(!errcount || !(errcount % 3))
			{
				fprintf(stderr, "Type %s%sHELP or %s%sHELP "
					"<cmd> for help.\n", pqpath,
					!pqpathlen ? "" : " ", pqpath,
					!pqpathlen ? "" : " ");

				errcount++;
			}

			return -1;
		}
		else if(pqlnk && pqlnk->pqf)
		{
			break;
		}
		else if(pqid == QUALIFIER(QR_SOCKET))
		{
			vsaddr.sun_family = AF_LOCAL;
			sncopy(pqarg, vsaddr.sun_path, sizeof(vsaddr.sun_path));
#if HAVE_SUN_LEN
			vsaddr.sun_len = SUN_LEN(&vsaddr);
#endif
		}
		else if(pqid == PARAMETER(PN_EXIT) || pqid == PARAMETER(PN_QUIT))
		{
			return 0xDEAD;
		}
		else if(pqid == PARAMETER(PN_HELP))
		{
			argc -= pqindex;
			argv += pqindex;

			return pqhelp(argc, argv, pql);
		}
	}

	argc -= pqindex;
	argv += pqindex;

	/*
 	 * When there is no command, i.e. only a qualifier
	 * was specified, then enter interactive mode.
	 */

	if(!pqlnk || !pqlnk->pqf)
	{
		return 0xD00F;
	}

	/*
	 * Execute command.
	 */

	addpqpath(pqlnk->pqd);

	return pqlnk->pqf(argc, argv, pqlnk);
}

/*****************************************************************************
 * main handler:                                                             *
 *****************************************************************************/

int pqf_main(int argc, char *argv[], PQLINK *pql)
{
	uint32_t pqid;
	PQLINK *pqlnk = (PQLINK *)0;
	int ret;

	pqindex = 0;

	while((pqid = getnextpq(argc, argv, pql, &pqlnk)) != PQ_EXHAUSTED)
	{
		if(pqlnk && pqlnk->pqf)
		{
			break;
		}
	}

	if(!pqlnk)
	{
		register int i;
		register PQLINK *lnk;

		fprintf(stderr, "Unrecognized program name '%s' encountered.\n"
			"This program must be called as either:\n\n", argv[0]);

		for(i = 0, lnk = pql->link; i < pql->nlinks; i++, lnk++)
		{
			fprintf(stderr, "  %-20s - %s\n", lnk->pqd->name,
				lnk->desc);
		}

		printf("\nPlease rename the program to one of these names and "
			"try again.\n");

		return -1;
	}

	if(!pqlnk->pqf)
	{
		fprintf(stderr, "No action assigned with program name '%s'\n",
			pqlnk->pqd->name);

		return -1;
	}

	argc -= pqindex;
	argv += pqindex;

	addpqpath(pqlnk->pqd);

	ret = pqlnk->pqf(argc, argv, pqlnk);

	if(ret == 0xD00F)
		ret = interactive();

	if(ret == 0xDEAD)
		ret = 0;

	return ret;
}

/*****************************************************************************
 * PQLINK SETUP:                                                             *
 *****************************************************************************/

/* ADD */

PQLINK pql_add_aclrule[] =
{
	{
		&qn_accept,		0,
		0,			0,
		"The rule will accept connections rather than reject."
	},
	{
		&qn_reject,		0,
		0,			0,
		"The rule will reject connections (the default)."
	},
	{
		&qr_ttl,		0,
		0,			0,
		"Specifies the number of seconds until the rule expires."
	},
	{
		&qr_expires,		0,
		0,			0,
		"Specifies the date and time when the rule expires."
	},
	{
		&pr_address,		0,
		0,			0,
		"Specifies the address or network the rule applies to."
	}
};

PQLINK pql_add_user[] =
{
	{
		&pr_password,		0,
		0,			0,
		"Specifies the password for the new user account."
	}
};

PQLINK pql_add[] =
{
	{
		&pr_aclrule,		pqf_add_aclrule,
		pql_add_aclrule,	NPQL(pql_add_aclrule),
		"Add the specified rule to the access control list."
	},
	{
		&pr_user,		pqf_add_user,
		pql_add_user,		NPQL(pql_add_user),
		"Add the specified user to the user database."
	}
};

/* DELETE */

PQLINK pql_delete[] =
{
	{
		&pr_aclrule,		pqf_delete_aclrule,
		0,			0,
		"Delete the specified rule from the access control list."
	},
	{
		&pr_user,		pqf_delete_user,
		0,			0,
		"Delete the specified user from the user database."
	}
};

/* FLUSH */

PQLINK pql_flush[] =
{
	{
		&pn_acl,		pqf_flush_acl,
		0,			0,
		"Flush the server access control list."
	}
};

/* KILL */

PQLINK pql_kill[] =
{
	{
		&qn_silent,		0,
		0,			0,
		"Perform the operation 'silently'."
	},
	{
		&qr_user,		0,
		0,			0,
		"Kill the specified user."
	},
	{
		&qr_channel,		0,
		0,			0,
		"Kill all users on the specified conference channel."
	},
	{
		&qn_all,		0,
		0,			0,
		"Kill all users."
	}
};

/* SEND */

PQLINK pql_send[] =
{
	{
		&qn_broadcast,		0,
		0,			0,
		"Send a broadcast message to all logged on users."
	},
	{
		&qr_channel,		0,
		0,			0,
		"Send a message to the specified conference channel."
	},
	{
		&qr_user,		0,
		0,			0,
		"Send a message to the specified user."
	}
};

/* SET */

PQLINK pql_set[] =
{
	{
		&pr_anonymous,		pqf_set_anonymous,
		0,			0,
		"Set whether client hostnames are visible to others."
	},
	{
		&pr_dnschklvl,		pqf_set_dnschklvl,
		0,			0,
		"Set the DNS checking level required of clients."
	},
	{
		&pr_email,		pqf_set_email,
		0,			0,
		"Set whether sending E-Mail invitations is permissible."
	},
	{
		&pr_fgthreshold,	pqf_set_fgthreshold,
		0,			0,
		"Set the FloodGuard threshold time in sec."
	},
	{
		&pr_floodguard,		pqf_set_floodguard,
		0,			0,
		"Enable or disable the FloodGuard flood protection."
	},
	{
		&pr_regonly,		pqf_set_regonly,
		0,			0,
		"Set whether unregistered users are allowed to enter."
	},
	{
		&pr_servername,		pqf_set_servername,
		0,			0,
		"Set the server hostname as displayed to clients."
	},
	{
		&pr_socket,		pqf_set_socket,
		0,			0,
		"Set the socket to send control commands to."
	}
};

/* SHOW */

PQLINK pql_show_lastlog[] =
{
	{
		&qr_address,		0,
		0,			0,
		"Restrict display to logins from within specified network."
	},
	{
		&qr_host,		0,
		0,			0,
		"Restrict display to logins from the given hostname."
	},
	{
		&qr_user,		0,
		0,			0,
		"Show logins of the specified nickname only."
	},
	{
		&qr_records,		0,
		0,			0,
		"List at most this many lastlog records."
	},
	{
		&qr_since,		0,
		0,			0,
		"Restrict display to the time since the specified date."
	},
	{
		&qr_until,		0,
		0,			0,
		"Restrict display to the time until the specified date."
	},
	{
		&qr_uname,		0,
		0,			0,
		"Show logins of the specified UNIX username only."
	},
	{
		&qn_wide,		0,
		0,			0,
		"Use wide output list format."
	}
};

PQLINK pql_show_users[] =
{
	{
		&qr_channel,		0,
		0,			0,
		"Show users on the specified conference channel only."
	}
};

PQLINK pql_show[] =
{
	{
		&pn_acl,		pqf_show_acl,
		0,			0,
		"Show the current access control list setup."
	},
	{
		&pn_anonymous,		pqf_show_anonymous,
		0,			0,
		"Show whether the server is operating in anonymous mode."
	},
	{
		&pn_dnschklvl,		pqf_show_dnschklvl,
		0,			0,
		"Show the DNS checking level that is required of clients."
	},
	{
		&pn_email,		pqf_show_email,
		0,			0,
		"Show whether it is allowed to send E-Mail invitations."
	},
	{
		&pn_fgthreshold,	pqf_show_fgthreshold,
		0,			0,
		"Show the configured FloodGuard threshold time."
	},
	{
		&pn_floodguard,		pqf_show_floodguard,
		0,			0,
		"Show whether the FloodGuard flood protection is enabled."
	},
	{
		&pn_lastlog,		pqf_show_lastlog,
		pql_show_lastlog,	NPQL(pql_show_lastlog),
		"Show the list of last logged on users."
	},
	{
		&pn_regonly,		pqf_show_regonly,
		0,			0,
		"Show whether only registered users are allowed to enter."
	},
	{
		&pn_servername,		pqf_show_servername,
		0,			0,
		"Show the currently configured server hostname."
	},
	{
		&pn_socket,		pqf_show_socket,
		0,			0,
		"Show the socket where control commands are sent to."
	},
	{
		&pn_uptime,		pqf_show_uptime,
		0,			0,
		"Show the current VChat server uptime."
	},
	{
		&pn_users,		pqf_show_users,
		pql_show_users,		NPQL(pql_show_users),
		"Show information about users."
	},
	{
		&pn_version,		pqf_show_version,
		0,			0,
		"Show the program version information."
	}
};

/* STOP */

PQLINK pql_stop[] =
{
	{
		&pn_server,		pqf_stop_server,
		0,			0,
		"Shut down the VChat conference server."
	}
};

/* VCHATCTL */

PQLINK pql_vchatctl[] =
{
	{
		&qr_socket,		0,
		0,			0,
		"Specifies the socket to send control commands to."
	},
	{
		&pn_add,		pqstdfunc,
		pql_add,		NPQL(pql_add),
		"Add items to server databases."
	},
	{
		&pn_delete,		pqstdfunc,
		pql_delete,		NPQL(pql_delete),
		"Delete items from server databases."
	},
	{
		&pn_exit,		0,
		0,			0,
		"Exit this program."
	},
	{
		&pn_flush,		pqstdfunc,
		pql_flush,		NPQL(pql_flush),
		"Flush the contents of certain server databases."
	},
	{
		&pn_help,		0,
		0,			0,
		"Show help. HELP <cmd> shows help about specific commands."
	},
	{
		&pn_kill,		pqf_kill,
		pql_kill,		NPQL(pql_kill),
		"Dispose of unwanted visitors."
	},
	{
		&pn_quit,		0,
		0,			0,
		"Quit this program."
	},
	{
		&pn_send,		pqf_send,
		pql_send,		NPQL(pql_send),
		"Send a message to a channel, user or all logged on users."
	},
	{
		&pn_set,		pqstdfunc,
		pql_set,		NPQL(pql_set),
		"Change configurable server settings."
	},
	{
		&pn_show,		pqstdfunc,
		pql_show,		NPQL(pql_show),
		"Show various configurable settings and other information."
	},
	{
		&pn_stop,		pqstdfunc,
		pql_stop,		NPQL(pql_stop),
		"Stop certain operations or the VChat server by itself."
	}
};

/* MAIN */

PQLINK pql_main[] =
{
	{
		&pn_vchatctl,		pqf_vchatctl,
		pql_vchatctl,		NPQL(pql_vchatctl),
		"VChat conference server control utility."
	},
	{
		&pn_vchatcgictl,	webui,
		0,			0,
		"Simple VChat server control CGI interface."
	},
	{
		&pn_vchatwclist,	webchatlist,
		0,			0,
		"Utility for listing your VChat server at webchat.de"
	}
};

/* MASTER */

PQLINK masterplan =
{
	0,			pqf_main,
	pql_main,		NPQL(pql_main),
	"Program master PQLINK."
};

/* INTERACTIVE */

PQLINK imaster =
{
	0,			pqf_vchatctl,
	&pql_vchatctl[1],	NPQL(pql_vchatctl)-1,
	"VChat conference server control utility."
};

/*****************************************************************************
 * ENTRY POINTS                                                              *
 *****************************************************************************/

int vchatctl(int argc, char *argv[])
{
	return pqf_vchatctl(argc, argv, &imaster);
}

int main(int argc, char *argv[])
{
	int ret = -1;

	prog_name = argv[0];

	{
		register char *s;

		while((s = strrchr(argv[0], '/')))
			argv[0] = ++s;
	}

	if(!sock_open())
	{
		ret = pqf_main(argc, argv, &masterplan);

		sock_close();
	}

	return ret;
}
