/*****************************************************************************
 * This file is part of the VChat conference server distribution.            *
 *                                                                           *
 * Copyright (c) 1993 - 2009 Andreas S. Wetzel                               *
 * All rights reserved.                                                      *
 *                                                                           *
 * The contents of this file are subject to the terms of the GNU General     *
 * Public License (GPL), version 2 only ("the License") as published by the  *
 * Free Software Foundation.                                                 *
 *                                                                           *
 * This Software comes with ABSOLUTELY NO WARRANTY.                          *
 * See the License for more details. You should have received a copy of the  *
 * License along with this distribution; See the file COPYING. If not, write *
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,   *
 * Boston, MA 02110-1301 USA.                                                *
 *****************************************************************************/
 
/* $Id: cmd_acl_delete.c,v 1.9 2009/08/14 11:54:49 mickey Exp $ */

#include "vserver.h"

/*
 * Delete a specific ACL rule.
 */

void cmd_acl_delete(CLDATA *ptr, void *data, size_t len)
{
	if(len == sizeof(uint16_t))
	{
		uint16_t rule = ntohs(*(uint16_t *)data);

		if(rule < 65535)
		{
			switch(acldb_delete(rule))
			{
				case 0: 	vcp_msg(ptr, "* delete 0x%04X",
							rule);
						break;

				case 1:		vcp_msg(ptr, "* No rule matching 0x%04X found",
							rule);
						break;

				case -1:	vcp_msg(ptr, "* Failed to delete ACL rule (%s)",
							strerror(errno));
						break;
			}
		}
		else
		{
			vcp_msg(ptr, "* The supplied rule number is out of range "
				"(0 <= n <= 65534)");
		}
	}
	else
	{
		vcp_msg(ptr, "* Invalid argument");
	}
}
