/*****************************************************************************
 * This file is part of the VChat conference server distribution.            *
 *                                                                           *
 * Copyright (c) 1993 - 2009 Andreas S. Wetzel                               *
 * All rights reserved.                                                      *
 *                                                                           *
 * The contents of this file are subject to the terms of the GNU General     *
 * Public License (GPL), version 2 only ("the License") as published by the  *
 * Free Software Foundation.                                                 *
 *                                                                           *
 * This Software comes with ABSOLUTELY NO WARRANTY.                          *
 * See the License for more details. You should have received a copy of the  *
 * License along with this distribution; See the file COPYING. If not, write *
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,   *
 * Boston, MA 02110-1301 USA.                                                *
 *****************************************************************************/
 
/* $Id: cmd_acl_list.c,v 1.11 2009/08/14 11:54:49 mickey Exp $ */

#include "vserver.h"

/*
 * Process ACL commands
 */

void cmd_acl_list(CLDATA *ptr, void *data, size_t len)
{
	int records = acldb_records();

	if(records >= 0)
	{
		TABLE cltab;

		table_init(&cltab, ptr);

		table_printf(&cltab, "\n*%s%s                                %s ACL SETUP %s                                  %s",
			S_BG_BLU, S_FG_WHT, S_BG_RED, S_BG_BLU, S_OFF);

		if(records > 0)
		{
			register ACLRULE *rp = acldb_addr(0);

			if(rp)
			{
				register int i;
				char buf[256];

				for(i = 0; i < records; i++, rp++)
				{
					acldb_print(rp, buf, sizeof(buf));
					table_xprintf(&cltab, "\n* %s", buf);
				}
			}
			else
			{
				table_xprintf(&cltab, "\n* ACL database failure (%s%s%s)",
					S_FG_RED, strerror(errno), S_OFF);
			}
		}

		table_xprintf(&cltab, "\n* 0xFFFF accept any");

		table_flush(&cltab);
	}
	else
	{
		vcp_msg(ptr, "* ACL database failure (%s%s%s)",
			S_FG_RED, strerror(errno), S_OFF);
	}
}
