/*****************************************************************************
 * This file is part of the VChat conference server distribution.            *
 *                                                                           *
 * Copyright (c) 1993 - 2009 Andreas S. Wetzel                               *
 * All rights reserved.                                                      *
 *                                                                           *
 * The contents of this file are subject to the terms of the GNU General     *
 * Public License (GPL), version 2 only ("the License") as published by the  *
 * Free Software Foundation.                                                 *
 *                                                                           *
 * This Software comes with ABSOLUTELY NO WARRANTY.                          *
 * See the License for more details. You should have received a copy of the  *
 * License along with this distribution; See the file COPYING. If not, write *
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,   *
 * Boston, MA 02110-1301 USA.                                                *
 *****************************************************************************/
 
/* $Id: cmd_broadcast.c,v 1.10 2009/08/14 11:54:49 mickey Exp $ */

#include "vserver.h"

/*
 * Send a broadcast message to all users.
 */

void cmd_broadcast(CLDATA *ptr, void *data, size_t len)
{
	char *msg = (char *)data;

	/*
	 * Remove control characters, leading and trailing whitespace
	 * from the message.
	 */

	trimstr(msg, SVMSGBUF);

	/*
	 * No message - No Broadcast.
	 */

	if(*msg)
	{
		int n = vcp_broadcast(ptr->nick, NULL, "%s", msg);

		vcp_msg(ptr, "* %s%d%s user%s notified",
			S_FG_GRN, n, S_OFF, (n == 1 ? "" : "s"));
	}
	else
	{
		vcp_msg(ptr, "* No message - no broadcast");
	}
}
