/*****************************************************************************
 * This file is part of the VChat conference server distribution.            *
 *                                                                           *
 * Copyright (c) 1993 - 2009 Andreas S. Wetzel                               *
 * All rights reserved.                                                      *
 *                                                                           *
 * The contents of this file are subject to the terms of the GNU General     *
 * Public License (GPL), version 2 only ("the License") as published by the  *
 * Free Software Foundation.                                                 *
 *                                                                           *
 * This Software comes with ABSOLUTELY NO WARRANTY.                          *
 * See the License for more details. You should have received a copy of the  *
 * License along with this distribution; See the file COPYING. If not, write *
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,   *
 * Boston, MA 02110-1301 USA.                                                *
 *****************************************************************************/
 
/* $Id: cmd_prvmsg.c,v 1.10 2009/08/14 11:54:50 mickey Exp $ */

#include "vserver.h"

/*
 * Send private chat message
 */

void cmd_prvmsg(CLDATA *ptr, void *data, size_t len)
{
	char *rcp = (char *)data;
	char *msg;

	/*
	 * Separate the message from the recipient nickname.
	 */

	if((msg = strchr(rcp, ' ')))
	{
		*msg++ = 0;

		/*
		 * Send the message.
		 */

		if(vcp_msgnick(rcp,  "(*%s%s%s*) %s", S_FG_MAG, ptr->nick,
			S_OFF, msg))
		{
			++ptr->prvmsgcnt;

			if(ptr->cl_opts & CL_OPT_PRVECHO)
			{
				vcp_msg(ptr, "(+%s%s%s+) %s",
					S_FG_CYN, rcp, S_OFF, msg);
			}
		}
		else
		{
			vcp_msg(ptr, "* Nickname '%s%s%s' not found",
				S_FG_RED, S_OFF, rcp);
		}
	}
	else
	{
		vcp_msg(ptr, "* Invalid argument");
	}
}
