/*****************************************************************************
 * This file is part of the VChat conference server distribution.            *
 *                                                                           *
 * Copyright (c) 1993 - 2009 Andreas S. Wetzel                               *
 * All rights reserved.                                                      *
 *                                                                           *
 * The contents of this file are subject to the terms of the GNU General     *
 * Public License (GPL), version 2 only ("the License") as published by the  *
 * Free Software Foundation.                                                 *
 *                                                                           *
 * This Software comes with ABSOLUTELY NO WARRANTY.                          *
 * See the License for more details. You should have received a copy of the  *
 * License along with this distribution; See the file COPYING. If not, write *
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,   *
 * Boston, MA 02110-1301 USA.                                                *
 *****************************************************************************/
 
/* $Id: ascii.h,v 1.4 2009/08/14 11:54:53 mickey Exp $ */

#ifndef __ASCII_H__
#define __ASCII_H__

/***************************************
 * ASCII control-character definitions *
 ***************************************/

#define		NUL		0x00
#define		SOH		0x01 
#define		STX		0x02 
#define		ETX		0x03 
#define		EOT		0x04
#define		ENQ		0x05  
#define		ACK		0x06
#define		BEL		0x07 
#define         BS		0x08 
#define		HT		0x09 
#define		LF		0x0A
#define		VT		0x0B
#define		FF		0x0C 
#define		CR		0x0D
#define		SO		0x0E  
#define		SI		0x0F
#define		DLE		0x10
#define		DC1		0x11
#define		DC2		0x12
#define		DC3		0x13
#define		DC4		0x14
#define		NAK		0x15
#define		SYN		0x16
#define		ETB		0x17
#define		CAN		0x18
#define		EM		0x19 
#define		SUB		0x1A
#define		ESC		0x1B
#define		FS		0x1C
#define		GS		0x1D
#define		RS		0x1E
#define		US		0x1F
#define		DEL		0x7F

#define		IND		0x84
#define		NEL		0x85
#define		SSA		0x86
#define		ESA		0x87
#define		HTS		0x88
#define		HTJ		0x89
#define		VTS		0x8A
#define		PLD		0x8B
#define		PLU		0x8C
#define		RI		0x8D
#define		SS2		0x8E
#define		SS3		0x8F
#define		DCS		0x90
#define		PU1		0x91
#define		PU2		0x92
#define		STS		0x93
#define		CCH		0x94
#define		MW		0x95
#define		SPA		0x96
#define		EPA		0x97

#define		CSI		0x9B
#define		ST		0x9C
#define		OSC		0x9D
#define		PM		0x9E
#define		APC		0x9F

/***************************
 * Control key definitions *
 ***************************/

#define		CTL_A		SOH
#define		CTL_B		STX
#define		CTL_C		ETX
#define		CTL_D		EOT
#define		CTL_E		ENQ
#define		CTL_F		ACK
#define		CTL_G		BEL
#define         CTL_H		BS
#define		CTL_I		HT
#define		CTL_J		LF
#define		CTL_K		VT
#define		CTL_L		FF
#define		CTL_M		CR
#define		CTL_N		SO
#define		CTL_O		SI
#define		CTL_P		DLE
#define		CTL_Q		DC1
#define		CTL_R		DC2
#define		CTL_S		DC3
#define		CTL_T		DC4
#define		CTL_U		NAK
#define		CTL_V		SYN
#define		CTL_W		ETB
#define		CTL_X		CAN
#define		CTL_Y		EM
#define		CTL_Z		SUB

#endif /* __ASCII_H__ */
