/*****************************************************************************
 * This file is part of the VChat conference server distribution.            *
 *                                                                           *
 * Copyright (c) 1993 - 2009 Andreas S. Wetzel                               *
 * All rights reserved.                                                      *
 *                                                                           *
 * The contents of this file are subject to the terms of the GNU General     *
 * Public License (GPL), version 2 only ("the License") as published by the  *
 * Free Software Foundation.                                                 *
 *                                                                           *
 * This Software comes with ABSOLUTELY NO WARRANTY.                          *
 * See the License for more details. You should have received a copy of the  *
 * License along with this distribution; See the file COPYING. If not, write *
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,   *
 * Boston, MA 02110-1301 USA.                                                *
 *****************************************************************************/
 
/* $Id: defaults.h,v 1.3 2009/08/14 11:54:53 mickey Exp $ */

/*
 * Program default values.
 * These values may be overridden at run-time by using the corresponding
 * commandline options of vserver. See vserver(8) for details.
 */

#ifndef __DEFAULTS_H__
#define __DEFAULTS_H__

/*
 * The default number of logfile generations that vserver will
 * keep when rotating logfiles via SIGUSR1.
 */

#define	DEFAULT_NUMLOGFILES	8

/*
 * The default maximum number of pending connection requests
 * that vserver will support.
 */

#define	DEFAULT_MAX_PENDING	4

/*
 * The default TCP port number that vserver will listen on
 * for incoming connection requests of remote clients.
 */

#define	DEFAULT_SERVER_PORT	1168

/*
 * The default number of lastlog entries stored.
 */

#define	DEFAULT_LASTLOG_ENTRIES	16383

/*
 * The default time span used by the flood guard feature
 * to limit connection attempts and messages received by
 * unregistered users.
 */

#define DEFAULT_FLOODGUARD_SEC	1
#define DEFAULT_FLOODGUARD_USEC	0

#endif /* __DEFAULTS_H__ */
